angular.module('beamng.apps')
.directive('minForcedInduction', ['$log', 'bngApi', 'StreamsManager', 'UiUnits', 'Utils', function ($log, bngApi, StreamsManager, UiUnits, Utils) {
  return {
    template: 
        '<object style="width:100%; height:100%; visibility: hidden; box-sizing:border-box; pointer-events: none" type="image/svg+xml" data="modules/apps/minForcedInduction/minforcedinduction.svg?t=' + Date.now() + '"/>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      
      element.on('load', function () {
        var svg = element[0].contentDocument;
        svg.roundDec = Utils.roundDec;


        scope.$on('VechicleChange', svg.reset);
        
        scope.$on('VehicleFocusChanged', function (event, data) {
          if(data.mode == 1 && svg && svg.reset) {
             svg.reset();
          }
        });

        scope.$on('streamsUpdate', (ev, streams) => {
          // todo: this function is bullshit visibility should be dependent on the lua module beeing loaded or not, not on data being present
          if (svg.isStreamValid(streams)) {
            element[0].style.visibility = '';
            svg.update(streams);
          } else {
            element[0].style.visibility = 'hidden';
          }
        });

        svg.wireThroughUnitSystem((val, func) => UiUnits[func](val));

        StreamsManager.add(svg.getStreams());
        scope.$on('$destroy', function () {
          StreamsManager.remove(svg.getStreams());
        });
      });
    }
  }
}])